/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.felix.scr.impl.inject;

import org.apache.felix.scr.impl.logger.ComponentLogger;
import org.apache.felix.scr.impl.metadata.ComponentMetadata;

/**
 * @version $Rev: 1813478 $ $Date: 2017-10-27 02:19:49 -0500 (Fri, 27 Oct 2017) $
 */
public interface ComponentMethods<T>
{
    void initComponentMethods( ComponentMetadata componentMetadata,
            Class<T> implementationObjectClass,
            ComponentLogger logger);

    LifecycleMethod getActivateMethod();

    LifecycleMethod getDeactivateMethod();

    LifecycleMethod getModifiedMethod();

    ReferenceMethods getBindMethods(String refName );

	ComponentConstructor<T> getConstructor();

}
